//Generated by the protocol buffer compiler. DO NOT EDIT!
// source: dsepractice/chinese/v1alpha1/core_types.proto

package gg.dsepractice.chinese.v1alpha1;

@kotlin.jvm.JvmName("-initializegameSession")
inline fun gameSession(block: gg.dsepractice.chinese.v1alpha1.GameSessionKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.GameSession =
  gg.dsepractice.chinese.v1alpha1.GameSessionKt.Dsl._create(gg.dsepractice.chinese.v1alpha1.GameSession.newBuilder()).apply { block() }._build()
object GameSessionKt {
  @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
  @com.google.protobuf.kotlin.ProtoDslMarker
  class Dsl private constructor(
    private val _builder: gg.dsepractice.chinese.v1alpha1.GameSession.Builder
  ) {
    companion object {
      @kotlin.jvm.JvmSynthetic
      @kotlin.PublishedApi
      internal fun _create(builder: gg.dsepractice.chinese.v1alpha1.GameSession.Builder): Dsl = Dsl(builder)
    }

    @kotlin.jvm.JvmSynthetic
    @kotlin.PublishedApi
    internal fun _build(): gg.dsepractice.chinese.v1alpha1.GameSession = _builder.build()

    /**
     * <code>string id = 1 [json_name = "id"];</code>
     */
    var id: kotlin.String
      @JvmName("getId")
      get() = _builder.getId()
      @JvmName("setId")
      set(value) {
        _builder.setId(value)
      }
    /**
     * <code>string id = 1 [json_name = "id"];</code>
     */
    fun clearId() {
      _builder.clearId()
    }

    /**
     * <code>string article_id = 5 [json_name = "articleId"];</code>
     */
    var articleId: kotlin.String
      @JvmName("getArticleId")
      get() = _builder.getArticleId()
      @JvmName("setArticleId")
      set(value) {
        _builder.setArticleId(value)
      }
    /**
     * <code>string article_id = 5 [json_name = "articleId"];</code>
     */
    fun clearArticleId() {
      _builder.clearArticleId()
    }

    /**
     * <code>optional .dsepractice.chinese.v1alpha1.GameSessionData data = 2 [json_name = "data"];</code>
     */
    var data: gg.dsepractice.chinese.v1alpha1.GameSessionData
      @JvmName("getData")
      get() = _builder.getData()
      @JvmName("setData")
      set(value) {
        _builder.setData(value)
      }
    /**
     * <code>optional .dsepractice.chinese.v1alpha1.GameSessionData data = 2 [json_name = "data"];</code>
     */
    fun clearData() {
      _builder.clearData()
    }
    /**
     * <code>optional .dsepractice.chinese.v1alpha1.GameSessionData data = 2 [json_name = "data"];</code>
     * @return Whether the data field is set.
     */
    fun hasData(): kotlin.Boolean {
      return _builder.hasData()
    }
    val GameSessionKt.Dsl.dataOrNull: gg.dsepractice.chinese.v1alpha1.GameSessionData?
      get() = _builder.dataOrNull

    /**
     * <code>.google.protobuf.Timestamp created_at = 3 [json_name = "createdAt"];</code>
     */
    var createdAt: com.google.protobuf.Timestamp
      @JvmName("getCreatedAt")
      get() = _builder.getCreatedAt()
      @JvmName("setCreatedAt")
      set(value) {
        _builder.setCreatedAt(value)
      }
    /**
     * <code>.google.protobuf.Timestamp created_at = 3 [json_name = "createdAt"];</code>
     */
    fun clearCreatedAt() {
      _builder.clearCreatedAt()
    }
    /**
     * <code>.google.protobuf.Timestamp created_at = 3 [json_name = "createdAt"];</code>
     * @return Whether the createdAt field is set.
     */
    fun hasCreatedAt(): kotlin.Boolean {
      return _builder.hasCreatedAt()
    }

    /**
     * <code>.google.protobuf.Timestamp must_end_before = 4 [json_name = "mustEndBefore"];</code>
     */
    var mustEndBefore: com.google.protobuf.Timestamp
      @JvmName("getMustEndBefore")
      get() = _builder.getMustEndBefore()
      @JvmName("setMustEndBefore")
      set(value) {
        _builder.setMustEndBefore(value)
      }
    /**
     * <code>.google.protobuf.Timestamp must_end_before = 4 [json_name = "mustEndBefore"];</code>
     */
    fun clearMustEndBefore() {
      _builder.clearMustEndBefore()
    }
    /**
     * <code>.google.protobuf.Timestamp must_end_before = 4 [json_name = "mustEndBefore"];</code>
     * @return Whether the mustEndBefore field is set.
     */
    fun hasMustEndBefore(): kotlin.Boolean {
      return _builder.hasMustEndBefore()
    }

    /**
     * <code>.dsepractice.chinese.v1alpha1.GameSessionStatus status = 6 [json_name = "status"];</code>
     */
    var status: gg.dsepractice.chinese.v1alpha1.GameSessionStatus
      @JvmName("getStatus")
      get() = _builder.getStatus()
      @JvmName("setStatus")
      set(value) {
        _builder.setStatus(value)
      }
    /**
     * <code>.dsepractice.chinese.v1alpha1.GameSessionStatus status = 6 [json_name = "status"];</code>
     */
    fun clearStatus() {
      _builder.clearStatus()
    }
  }
}
inline fun gg.dsepractice.chinese.v1alpha1.GameSession.copy(block: gg.dsepractice.chinese.v1alpha1.GameSessionKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.GameSession =
  gg.dsepractice.chinese.v1alpha1.GameSessionKt.Dsl._create(this.toBuilder()).apply { block() }._build()

val gg.dsepractice.chinese.v1alpha1.GameSessionOrBuilder.dataOrNull: gg.dsepractice.chinese.v1alpha1.GameSessionData?
  get() = if (hasData()) getData() else null

val gg.dsepractice.chinese.v1alpha1.GameSessionOrBuilder.createdAtOrNull: com.google.protobuf.Timestamp?
  get() = if (hasCreatedAt()) getCreatedAt() else null

val gg.dsepractice.chinese.v1alpha1.GameSessionOrBuilder.mustEndBeforeOrNull: com.google.protobuf.Timestamp?
  get() = if (hasMustEndBefore()) getMustEndBefore() else null

